#ifndef SCENE_H
#define SCENE_H

#include <vector>
#include "matrix.h"

class SGNode{
protected:
	Matrix					relativematrix, globalmatrix;
	bool					validglobalmatrix;
	float					color[3];
	SGNode*					parentnode;
	std::vector<SGNode*>	nodes;
	
public:
	SGNode();
	virtual ~SGNode();

	virtual void predraw();
	virtual void draw();
	virtual void drawgeometry(){}

	virtual void SetColor( const float& r, const float& g, const float& b );
	virtual void SetMatrix( const Matrix& newmatrix );
	virtual void SetIdMatrix( );
	virtual void RotateX( const float& angle );
	virtual void RotateY( const float& angle );
	virtual void RotateZ( const float& angle );
	virtual void Translate( const float& x, const float& y, const float& z );

	virtual void AddNode( SGNode* node );
};


class SceneGraph{
	SGNode *rootNode;

public:
	SceneGraph();
	virtual ~SceneGraph();

	void setRootNode( SGNode* node );
	void draw( );
};

#endif
